#pragma once

#include "DirectXBase.h"

// This class renders simple text with a colored background.
ref class BouncingBallRenderer sealed : public DirectXBase
{
public:
    BouncingBallRenderer();

    // DirectXBase methods.
    virtual void CreateDeviceIndependentResources() override;
    virtual void CreateDeviceResources() override;
    virtual void CreateWindowSizeDependentResources() override;
    virtual void Render() override;

    // Method for updating time-dependent objects.
    void Update(float timeTotal, float timeDelta);

    // Methods to adjust the ball color.
    void BallColorNext();
    void BallColorPrevious();

    // Methods to save and load state in response to suspend.
    void SaveInternalState(Windows::Foundation::Collections::IPropertySet^ state);
    void LoadInternalState(Windows::Foundation::Collections::IPropertySet^ state);

private:

    typedef struct _BALLINFO 
    {
        int width;
        int height;
        int X;
        int Y;

        int dX;
        int dY;
    }BALLINFO;

    Microsoft::WRL::ComPtr<ID2D1SolidColorBrush> m_blackBrush;
    BALLINFO m_ballPosition;
    bool m_renderNeeded;
    int m_ballColorIndex;
    static const int BALL_DELTA = 2;
};
