﻿//
// BlankPage.xaml.h
// Declaration of the BlankPage.xaml class.
//

#pragma once

#include "DirectXPage.g.h"
#include "BouncingBallRenderer.h"

namespace DXBouncingBall
{
    /// <summary>
    /// A DirectX page that can be used on its own.  Note that it may not be used within a Frame.
    /// </summary>
    [Windows::Foundation::Metadata::WebHostHidden]
    public ref class DirectXPage sealed
    {
    public:
        DirectXPage();

        void OnPreviousColorPressed(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);
        void OnNextColorPressed(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e);

        void SaveInternalState(Windows::Foundation::Collections::IPropertySet^ state);
        void LoadInternalState(Windows::Foundation::Collections::IPropertySet^ state);

        property Windows::Foundation::EventRegistrationToken RenderRegistrationToken
        {
            Windows::Foundation::EventRegistrationToken get()
            {
                return m_eventToken;
            }
        }

    private:
        void OnWindowSizeChanged(Windows::UI::Core::CoreWindow^ sender, Windows::UI::Core::WindowSizeChangedEventArgs^ args);
        void OnLogicalDpiChanged(Platform::Object^ sender);
        void OnOrientationChanged(Platform::Object^ sender);
        void OnDisplayContentsInvalidated(Platform::Object^ sender);
        void OnRendering(Object^ sender, Object^ args);

        Windows::Foundation::EventRegistrationToken m_eventToken;

        BouncingBallRenderer^ m_renderer;        
    };
}
